random(n)
{	/* return a random integer from 0 - n */
	int	c, d, e;

	outp(0x43,0x00);
	c=inp(0x40)+(inp(0x40) << 8);

	outp(0x43,0x40);
	d=inp(0x41)+(inp(0x41) << 8);

	e = ((c*d) >> 8) & 255;

	return((e * ++n) >> 8);
}


abs(value)
int	value;
{	/* return the absolute value */
	if(value<0)
		value=-value;
	return(value);
}



cosine(x)
int	x;
{
	x+=90;
	if(x>=360)
		x-=360;
	return(sine(x));
}


sine(x)
int	x;
{
	int	a, f, quad;
	switch(x/90) {
	case 0:	/* first quadrent */
		f=x; quad=1;
		break;
	case 1:	/* second quadrent */
		f=180-x; quad=1;
		break;
	case 2:	/* third quadrent */
		f=x-180; quad=-1;
		break;
	case 3:	/* forth quadrent */
		f=360-x; quad=-1;
		break;
	default:
		cprintf("error in sine    %d  \n\r",x);
		break;
	}
	
        switch(f/10) {
	case 0:
		a=0;
		break;
	case 1:
		a=17 *quad;
		break;
	case 2:
		a=34 *quad;
		break;
	case 3:
		a=49 *quad;
		break;
	case 4:
		a=64 *quad;
		break;
	case 5:
		a=76 *quad;
		break;
	case 6:
		a=86 *quad;
		break;
	case 7:
		a=93 *quad;
		break;
	case 8:
		a=98 *quad;
		break;
	case 9:
		a=100 *quad;
		break;
	default:
		cprintf("error in sine value gen \n\r");
		break;
	}

	return(a);

		
}


sleep(time)
int	time;
{
	int	a,b;

	for(a=0; a<time; a++) {
		for(b=0; b<100; b++);
	}
}
