/*
*****************************************************************************************************
*****************************************************************************************************
*****                                                                                           *****
*****                  Task Z   -   Task dispatcher                                             *****
*****                                                                                           *****
*****                                                                                           *****
*****                                                                                           *****
*****            Level of Play          Number of Traps                    Number of Styx       *****
*****                                                                                           *****
*****                                                                                           *****
*****                  1                  1                                       1             *****
*****                  2                  2                                       1             *****
*****                  3                  2                                       2             *****
*****                  4 & above          2 Lengthening                           2             *****
*****                                                                                           *****
*****                                                                                           *****
*****                                                                                           *****
*****************************************************************************************************
*****************************************************************************************************
*/

#include	"styx.h"

int	dead, lives, level, full, dummy;


main()
{
	int	loop, temp, y, copyok, flag;

	dummy=175;	/* rounds off checksum during creation */

	copyok=0;	/* flag to indicate copy protection */

	mesage();	/* display message to turn on the color display */

	if(!medres(0))	/* if no color card is present then the program loops for ever */
		endloop();

        copyok=prochk();	/* set up copy protect flag */
	if(!copyok)
		nfg_crash();	/* exit if it is an illegal copy */
	
	kb_init(); keychr=0;	/* initialize the keyboard */ 

	init_hi_score(); init_sound();	/* initialize high score & sound */

	init_joy();	/* initialize the joystick */
	medres(0);	/* clear the screen to med-res */ 


	mclear (); 

	med_txt("For more information about",5,5,7);
	med_txt("other exciting entertainment",5,6,7);
	med_txt("products, write to us at:",5,7,7);


	med_txt("Windmill Software Inc.",8,9,7);
	med_txt("2209 Leominster Drive",8,10,7);
	med_txt("Burlington, Ontario",8,11,7);
	med_txt("CANADA   L7P 3W8",8,12,7);

	med_txt("STYX is available for the PC,",5,16,7);
	med_txt("XT, AT and compatibles.",5,17,7);
	med_txt("A special version is also ",5,18,7);
	med_txt("available for the IBM PCjr.",5,19,7);

	med_txt("Thank You for your support.",5,22,7);

	med_txt("Press any key ...",21,24,7);
	start_wait();	/* exit if a key has been pressed */

#ifdef	FREEDEMO

	mclear ();

	med_txt("This is a demonstration copy",5,1,7);
	med_txt("of STYX. The game is completely",5,2,7);
	med_txt("functional except that only the",5,3,7);
	med_txt("first round is enabled and",5,4,7);
	med_txt("high scores are not saved.",5,5,7);

	med_txt("This demonstration program may",5,7,7);
	med_txt("be copied and passed on to your",5,8,7);
	med_txt("friends.  We hope that you and",5,9,7);
	med_txt("your friends will enjoy STYX.",5,10,7);

	med_txt("To purchase STYX along with a",5,12,7);
	med_txt("full color illustrated manual,",5,13,7);
	med_txt("please send $39.95 to:",5,14,7);

	med_txt("Windmill Software Inc.",8,17,7);
	med_txt("2209 Leominster Drive",8,18,7);
	med_txt("Burlington, Ontario",8,19,7);
	med_txt("CANADA   L7P 3W8",8,20,7);

	
	med_txt("Press any key ...",21,24,7);
	start_wait();	/* exit if a key has been pressed */






	mclear ();

	med_txt("INSTRUCTIONS",15,1,7);

	med_txt("Use the numeric keypad to direct your" ,3,3,7);
	med_txt("marker in any of eight directions    " ,3,4,7);
	med_txt("around the playing field     " ,3,5,7);
	med_txt("                                     " ,3,6,7);
	med_txt("              8                     " ,3,7,7);
	med_txt("           7     9                  " ,3,8,7);
	med_txt("              |                      " ,3,9,7);
	med_txt("         4 ---|--- 6             " ,3,10,7);
	med_txt("              |                      " ,3,11,7);
	med_txt("           1     3                " ,3,12,7);
	med_txt("              2                      " ,3,13,7);
	med_txt("                                     " ,3,14,7);
	med_txt("Then, hold down F1 to enter the      " ,3,15,7);
	med_txt("uncharted area.                      " ,3,16,7);







	med_txt("'F9' controls the sound.",3,18,7);
	med_txt("SPACE BAR suspends game.",3,19,7);
	med_txt("Ctrl left & right arrow keys",3,20,7);
	med_txt("reposition the screen.",3,21,7);

	med_txt("Press any key ...",21,24,7);
	start_wait();	/* exit if a key has been pressed */




	mclear ();

	med_txt("SCORING",15,1,7);

	med_txt("The object of each round is to corner",3,3,7);
	med_txt("the STYX by capturing at least 80% of",3,4,7);
	med_txt("the playing field. If you claim more ",3,5,7);
	med_txt("than 80%, you are awarded 1000 bonus ",3,6,7);
	med_txt("points for each percent over 80%     ",3,7,7);
	med_txt("claimed.                             ",3,8,7);

	med_txt("As you claim each area, you get 10   ",3,10,7);
	med_txt("points for every percent of the field",3,11,7);
	med_txt("captured. If you time your capture,  ",3,12,7);
	med_txt("you can increase your score depending",3,13,7);
	med_txt("on the multiplier shown in the upper ",3,14,7);
	med_txt("corner of the screen.                ",3,15,7);
	med_txt("                                     ",3,16,7);
	med_txt("   Blue ...........  X 1             ",3,17,7);
	med_txt("   Red ............  X 5             ",3,18,7);
	med_txt("   Green ..........  X 10            ",3,19,7);

	med_txt("Press any key ...",21,24,7);
	start_wait();	/* exit if a key has been pressed */





#endif

	medres (0);

	/* determine system clock speed */
	find_speed();



	while(TRUE) {	/* continuous loop for game */

		if(!keychr || (keychr&0x80)) {	/* go directly to game if a key was pressed */
			medres(0);	/* clear the screen to med-res */ 
			outp(0x3d9,0);	/* switch to low intensity */	
			gentitle();	/* display title page in med-res */  
                	show_scores(); 	/* show high scores on title page */ 
		}
		init_joy();	/* initialize the joystick */
		start_wait();	/* wait for a key to be pressed or the joystick button */
				/* if the joystick is used - the stick MUST be centred when the button is pressed */
		keychr=0;	/* reset to prevent a pause when started with a space */
		screen=FALSE;	/* draw the new screen without being displayed */
		lowres(6);
		clear (0); 	/* clears the memory buffer alse */
		line(0+1,8+1,159-1,8+1,DARK_WHITE);
		line(159-1,8+1,159-1,99-1,DARK_WHITE);
		line(159-1,99-1,0+1,99-1,DARK_WHITE);
		line(0+1,99-1,0+1,8+1,DARK_WHITE);

		line(0+2,8+2,159-2,8+2,DARK_WHITE);
		line(159-2,8+2,159-2,99-2,DARK_WHITE);
		line(159-2,99-2,0+2,99-2,DARK_WHITE);
		line(0+2,99-2,0+2,8+2,DARK_WHITE);

		level=1; lives=3; 
		rst_score(); init_th(); /* reset score & sound */
		keychr=0;
		init_level();
		screen=TRUE;
		retscn();	/* get screen from the memory buffer */

		while(lives) {	/* loop while the player has lives left */

			dead=FALSE;	/* reset player dead status flag */
			while(!dead && !full) {

				if(!copyok)	/* continuous check for copy protect */
					nfg_crash();
				task_c();	/* move man */
				task_a();	/*    move styx */
				task_h();			/* update sound */
				task_b();	/* move traps */

				task_c();	/* move man */
				task_a();	/*    move styx */
				task_h();			/* update sound */
				task_b();	/* move traps */
				task_c();	/* move man */
				task_b();	/* move traps */

				task_c();	/* move man */
				task_a();	/*    move styx */
				task_h();			/* update sound */
				task_c();	/* move man */
				task_b();	/* move traps */

				task_f();	/* update scoring */
				exit_check();	/* check for a space key to pause game */
			}

			if(dead) {	/* man is dead */
				kill_man();	/* remove man */
				stop_traps();	/* remove traps */
				start_all_traps();	/* prepare traps for next time */
/* 				if(!fire)	/* used during debug as a no die option */   */
				lives--;
				print_present_score();	/* update score */
			}

			if(full) {	/* screen is full */
				sn2_off();	/* stop any sound */
				stop_traps();	/* remove traps */
				draw_man();	/* remove man from present position */
				check_bonus();	/* display bonus as it is awarded */
				empty_screen();	/* clear memory screen buffer & make sounds */
				level++;	/* advance level of play */
				if(level>9)
					level=9;

#ifdef	DEBUG
				cprintf("starting level %d \n\r",level);
#endif
				screen=FALSE;	/* blank out the top of the screen */
				for(y=0; y<9; y++) 
					line(0,y,159,y,BLACK);
				screen=TRUE;
				init_level();
				retscn();	/* return with the screen ready to start the next level */
			}

#ifdef	FREEDEMO

			if(level>1) {
				lives=0;
			}
#endif


		}

		check_hi_score();	/* check if a high score has been reached */

	}

}



mclear ()
{

	medres(0);


}


med_txt(string,x,y,color)
int	x,y,color;
char	*string;
{

	int	n=0;

	ttyrst(y,x);

	while(string[n]) {
		ttywrt(string[n++],color);
	}
}




init_level()	/* initialize variables for the present level of play */
{
	int	y;

	full=FALSE;
	init_ta();	/* set initial values of styx */
	init_tb();	/* clear all trap info tables */
	init_tc();	/* create man */
	init_tf();	/* reset scoring sequences */
	print_present_score();
}





empty_screen()	/* clear memory buffer & make full or high score sound */
{
	int	temp, y;

	init_sfull();
	screen=FALSE;	/* don't display untill done */

	for(y=11; y<28; y++)
		line(3,y,156,y,BLACK);
	temp=28;
	while(temp<97) {
		for(y=temp; y<temp+3; y++)
			line(3,y,156,y,BLACK);
		snd_sfull();
		temp+=3;
	}
	snd_slide();
	init_sfull();	/* turn off sound for the rest of the time */
	screen=TRUE;

}



make_dead(status)
int	status;
{
	dead=status;

}


make_full(val)
int	val;
{
	full=val;

}


get_status()
{
	if(dead || full)
		return(TRUE);
	else
		return(FALSE);

}


get_level()
{
	return(level);
}



make_level(x)
{
	level=x;

}


get_lives()
{
	return(lives);

}


exit_check()
{	/* check for a hold condition - also exit to dos during debug */

/*
	if(endgame) {	/*	removed for sale vertion  */
		rst_sound();
		kb_rst();  
		sn2_stop(); 
		_exit();
	}

*/

	if(keychr==57 || keychr==185) {	/* check for a hold condition */
		set_sound(40);	/* turn off sound */ 
		sn2_off();
		text_color(DARK_CYAN);	/* change text color */
		write_text("  PRESS ANY KEY ",0,1);	/* display message at top of screen */
		while(keychr==57)	/* hold game while pressing space key */
			set_sound(40);
		while(keychr & 0x80)	/* hold game while last character was a key up */
			set_sound(40);
		text_color(DARK_WHITE);	/* reset text color */
		write_text("                ",0,1);	/* blank area where message was displayed */
		print_present_score();	/* reprint top status line */
		keychr=0;	/* reset key incase game was restarted with a space key */
	}
}


endloop()
{
	int	temp;

	while(TRUE)
		temp=temp;	/* continuous loop trap */
}


nfg_crash()
{
	int	temp;

	medres(1);	/* restore med res mode */
	col_print("This program is copy protected",3);	/* print in white */
	endloop();
}
